
#include <iostream>

#include <QGLWidget>
#include <QOpenGLWidget>
#include <QApplication>
#include <QLabel>
#include <QMouseEvent>
#include <QHBoxLayout>
#include <QStackedWidget>

class GLWidget : public QGLWidget {
public:
	void mousePressEvent(QMouseEvent* event) {
		if (event->button() == Qt::LeftButton)
			std::cout << "Left button" << std::endl;
		else if (event->button() == Qt::RightButton)
			std::cout << "Right button" << std::endl;

		if (event->button() == Qt::RightButton) {
			std::cout << "Switching" << std::endl;

			QStackedWidget* parent = static_cast<QStackedWidget *>(this->parent());
			parent->widget((parent->currentIndex() + 1) % parent->count());
		}
	}
};


int main(int argc, char* argv[])
{
	QApplication app(argc, argv);

	QWidget widget;
	QHBoxLayout layout;

	QStackedWidget stacked;

	GLWidget widget1;
	GLWidget widget2;

	stacked.addWidget(&widget1);
	stacked.addWidget(&widget2);

	layout.addWidget(&stacked);

	QLabel label("Label");
	layout.addWidget(&label);

	widget.setLayout(&layout);

	widget.show();
	app.exec();
}
